#pragma once
#include "leet.h"

std::vector<std::vector<int>> Solution::threeSum(std::vector<int>& nums) {
	std::vector<std::vector<int>> ans;
	std::unordered_map<int, int> map;

	std::sort(nums.begin(), nums.end());

	if (nums.size() < 3) {                // Base Case 1
		return {};
	}
	if (nums[0] > 0) {                    // Base Case 2
		return {};
	}

	//itterate through map O(n^2) and create a map of the sums of each element
	for (int i = 0; i < nums.size(); i++)
		map[nums[i]] = i;

	for (int i = 0; i < nums.size(); i++)
	{
		if (nums[i] > 0)
			break;

		for (int j = i + 1; j < nums.size(); j++)
		{
			int numNeeded = (nums[i] + nums[j]) * -1;
			if (map.count(numNeeded) && map.find(numNeeded)->second > j)
				ans.push_back({ nums[i], nums[j], numNeeded });

			//Update J to avoid duplicates
			j = map.find(nums[j])->second;
		}

		//Update i to avoid duplicates
		i = map.find(nums[i])->second;
	}

	return ans;
}